#include "StdAfx.h"
#include "FixLine.h"

CFixLine::CFixLine(void)
{
	m_cOption.SetOptionFile(L"ATData\\FixLine.dat");
	m_cOption.OpenOptionFile();
	Initialize();
}

CFixLine::~CFixLine(void)
{
}

void CFixLine::Clear()
{
	m_FuncPool.clear();
	m_NamePool.clear();
	m_strRetChar.clear();
	m_nIgnoreLine=0;
	m_nMaxChar=2048;
	m_nMaxLine=12;
	m_bUseLimitLine=false;
	m_bIgnoreNonTrans=false;

	m_ElementPool.clear();
	m_nLineN=0;
	m_nSetIgnoredLine=0;
}

void CFixLine::Initialize()
{
	Clear();

	m_strRetChar = wtoa(m_cOption.GetOptionString(L"strRetChar"));
	m_nIgnoreLine = m_cOption.GetOptionInt(L"IgnoreLine");
	m_nMaxChar = m_cOption.GetOptionInt(L"MaxChar");
	m_nMaxLine = m_cOption.GetOptionInt(L"MaxLine");
	m_bUseLimitLine = m_cOption.GetOptionBool(L"UseLimitLine");
	m_bIgnoreNonTrans = m_cOption.GetOptionBool(L"IgnoreNonTrans");

	int nFuncN=0;
	while(m_cOption.IsInData(L"ElemType",nFuncN))
	{
		FLString FLTemp;
		FLTemp.SetType(m_cOption.GetOptionBool(L"ElemType",nFuncN));

		int nSubN=0;
		while(m_cOption.IsInData(L"ElemSubType",nFuncN,nSubN))
		{
			string strTemp = wtoa(m_cOption.GetOptionString(L"ElemSubString",nFuncN,nSubN));
			FLTemp.PushBack(
				m_cOption.GetOptionInt(L"ElemSubType",nFuncN,nSubN),
				DecodeLine(strTemp),
				m_cOption.GetOptionInt(L"ElemSubLen",nFuncN,nSubN),
				m_cOption.GetOptionBool(L"ElemSubDelete",nFuncN,nSubN)
				);

			nSubN++;
		}

		m_FuncPool.push_back(FLTemp);

		nFuncN++;
	}

	int nNameN=0;
	while(m_cOption.IsInData(L"Name",nNameN))
	{
		m_NamePool.insert(wtoa(m_cOption.GetOptionString(L"Name",nNameN)));
		nNameN++;
	}
}

void CFixLine::PreFixLine(LPSTR szDest,LPCSTR szSource)
{
	//ϴ ʱȭ
	m_ElementPool.clear();
	m_nLineN=0;
	m_nSetIgnoredLine=0;

	//FixLine ó 
	
	//1. ó
	//2. Լ ɰ(FindFunc )
	//3. Լ ؽƮ ɰ ִ´.
	//4. ȯ!

	
	//ó Ģ
	//ӵ  ,
	//  óϴ° Ģ
	
	string strStep0 = szSource;

	//1-1.    
	m_nLineN=1;
	while(1)
	{
		int nIdx=0;
		nIdx=Find(strStep0,m_strRetChar,nIdx,932);
		
		if(nIdx>=0)
		{
			m_nLineN++;
			nIdx++;
		}
		else
		{
			break;
		}
	}

	//1-2. ̸ ó  IgnoreLine üũ
	if(m_nIgnoreLine<0)
	{
		//̸ ó
		int n1stReturn = Find(strStep0,m_strRetChar,0,932);
		if(n1stReturn <0)
			n1stReturn = strStep0.length();

		if(m_NamePool.count(strStep0.substr(0,n1stReturn))>0)
		{
			m_nSetIgnoredLine =1;
		}
		else
		{
			m_nSetIgnoredLine =0;
		}
	}
	else
	{
		//⺻ 
		if(m_nIgnoreLine>m_nLineN)
			m_nSetIgnoredLine = m_nLineN;
		else
			m_nSetIgnoredLine = m_nIgnoreLine;
	}

	//1-3  ġ

	//string strStep0 = szSource;
	string strStep1;
	while(1)
	{
		int nLineN=1;
		int nHeadidx=0;
		int nTailIdx=0;
		nTailIdx=Find(strStep0,m_strRetChar,nHeadidx,932);
		
		if(nTailIdx>=0)
		{
			//Ignore Ϲ 
			if(nLineN<=m_nSetIgnoredLine && m_nSetIgnoredLine<m_nLineN)
			{
				strStep1 += strStep0.substr(nHeadidx,nTailIdx-nHeadidx+m_strRetChar.length());
				nHeadidx = nTailIdx + m_strRetChar.length();
			}
			else
			{
				strStep1 += strStep0.substr(nHeadidx,nTailIdx-nHeadidx);
				nHeadidx = nTailIdx + m_strRetChar.length();
			}
			nLineN++;
		}
		else
		{
			strStep1 += strStep0.substr(nHeadidx);
			break;
		}
	}

	int nHeadidx=0;
	int nTailidx=0;

	//2-1. Ignoreθŭ ̸ ߰صд.
	int nStep2idx=0;
	int nIgnoreSize=0;
	for(int i=0;i<m_nSetIgnoredLine;i++)
	{
		nStep2idx = Find(strStep1,m_strRetChar,nStep2idx,932);
		if(nStep2idx <0)
		{
			nStep2idx = strStep1.length();
			break;
		}

		nStep2idx+= m_strRetChar.length();
	}
	if(nStep2idx>0)
	{
		nStep2idx += m_strRetChar.length();
		m_ElementPool.push_back(
			FLString(strStep1.substr(0,nStep2idx),m_bIgnoreNonTrans*2+1));
		nIgnoreSize = nStep2idx;
	}
	nTailidx = nIgnoreSize;
	nHeadidx = nIgnoreSize;


	//2-2. Լ ɰ
	
	for(;nTailidx<strStep1.length();nTailidx++)
	{
		int nMinTempidx=65536;
		int nTempFunc=-1;
		for(int j=0;j<m_FuncPool.size();j++)
		{
			if(strStep1.compare(
					nTailidx,
					m_FuncPool[j].GetSubString(0).length(),
					m_FuncPool[j].GetSubString(0))	==0)
			{
				//˻ 
				int nTempidx=nTailidx+1;
				int k=1;
				for(;k<m_FuncPool[j].GetSize();k++)
				{
					if(m_FuncPool[j].GetSubType(k)>=4)
					{
						nTempidx = Find(strStep1,m_FuncPool[j].GetSubString(k),nTempidx,932);
						if(nTempidx<0)
						{
							nTempidx=65536;
							break;
						}// nTempid<0
					}//m_FuncPool[j].GetSubType
				}//for m_FuncPool[j].GetSize()
				
				if(nTempidx<65536)
				{
					nTempidx += m_FuncPool[j].GetSubString(k-1).length();
				}

				if(nTempidx<nMinTempidx)
				{
					nMinTempidx = nTempidx;
					nTempFunc = j;
				}
			}//if strStep1.compare Լ

		}//for m_FuncPool.size()

		if(nMinTempidx<65536 && nTempFunc>=0)
		{
			//պκ ؽƮ ߰
			if(nTailidx-nHeadidx > 0)
			{
				m_ElementPool.push_back(
					FLString(
						strStep1.substr(nHeadidx,nTailidx-nHeadidx)
					));
			}

			m_ElementPool.push_back(
				FLString(
					strStep1.substr(nTailidx,nMinTempidx-nTailidx),m_FuncPool[nTempFunc]
				));

			nHeadidx	= nMinTempidx;
			nTailidx		= nMinTempidx;
		}
		else if(IsDBCSLeadByteEx(932,strStep1[nTailidx]))
		{
			nTailidx++;
		}

	}//for strStep1.length()

	if(strStep1.length()-nHeadidx>0)
	{
		m_ElementPool.push_back(FLString(strStep1.substr(nHeadidx,nTailidx-nHeadidx)));
	}


	//3. Լ ؽƮ ɰ ִ´.

	int nBufSize=0;
	//ֿ ؽƮ 
	for(int i=0;i<m_ElementPool.size();i++)
	{
		for(int j=0;j<m_ElementPool[i].GetSize();j++)
		{
			if(m_ElementPool[i].GetSubType(j)==0 && !m_ElementPool[i].GetDelete(j))
			{
				nBufSize += sprintf_s(szDest+nBufSize,2048-nBufSize,
					"&*!%d_%d_%s",
					i,j,m_ElementPool[i].GetSubString(j).c_str());
			}
		}
	}
	//   ؽƮ(  ϴ) 
	for(int i=0;i<m_ElementPool.size();i++)
	{
		if(m_ElementPool[i].GetType()==1)
		{
			for(int j=0;j<m_ElementPool[i].GetSize();j++)
			{
				if(m_ElementPool[i].GetSubType(j)==1 && !m_ElementPool[i].GetDelete(j))
				{
					nBufSize += sprintf_s(szDest+nBufSize,2048-nBufSize,
						"&*!%d_%d_%s",
						i,j,m_ElementPool[i].GetSubString(j).c_str());
				}
			}
		}
	}
}

void CFixLine::PostFixLine(LPSTR szDest,LPCSTR szSource)
{
	//FixLine ó 

	//1. ɰ ElementPool 
	//2. ټ 簡 

	string strStep0 = szSource;

	//1. ɰ ElementPool 	
	int nStep0idx=0;
	nStep0idx=Find(strStep0,"&*!",nStep0idx,949);
	while(1)
	{
		if(nStep0idx<0)
			break;

		int nTempidx1 = Find(strStep0,"_",nStep0idx+3,949);
		if(nTempidx1<0)
			break;

		int nTempidx2 = Find(strStep0,"_",nTempidx1+1,949);
		if(nTempidx2<0)
			break;

		int nTempidx3 = Find(strStep0,"&*!",nTempidx2+1,949);
		if(nTempidx3<0)
			nTempidx3=strStep0.length();

		int i = atoi(strStep0.substr(nStep0idx+3,nTempidx1-nStep0idx-3).c_str());
		int j = atoi(strStep0.substr(nTempidx1+1,nTempidx2-nTempidx1-1).c_str());
		string k = strStep0.substr(nTempidx2+1,nTempidx3-nTempidx2-1);

		m_ElementPool[i].SetSubString(j,k);

		nStep0idx=nTempidx3;
	}

	//2. ټ 簡 
	int nLineN=0;
	int nChar=0;
	int nBufSize=0;
	int nMaxLine=0;

	if(m_bUseLimitLine) //ó
	{
		nMaxLine = m_nLineN;
	}
	else
	{
		nMaxLine = m_nMaxLine;
	}

	for(int i=0;i<m_ElementPool.size();i++)
	{
		if(i==0 &&m_nSetIgnoredLine!=0)
		{
			nBufSize += sprintf_s(szDest+nBufSize,2048-nBufSize,"%s",m_ElementPool[0].GetString().c_str());
		}
		else
		{
			if(nLineN >= nMaxLine)
				break;

			if(m_ElementPool[i].GetType())
			{
				//Լΰ ٿ ü  , ٷ .
				if(m_ElementPool[i].GetSize() <= m_nMaxChar)
				{
					if(nChar + m_ElementPool[i].GetSize() <= m_nMaxChar)
					{
						nChar += m_ElementPool[i].GetSize();
						nBufSize += sprintf_s(szDest+nBufSize,2048-nBufSize,"%s",m_ElementPool[i].GetString().c_str());
					}
					else
					{
						nChar = m_ElementPool[i].GetSize();
						nLineN++;
						nBufSize += sprintf_s(szDest+nBufSize,2048-nBufSize,"%s%s",m_strRetChar.c_str(),m_ElementPool[i].GetString().c_str());
					}
				}
			}
			else
			{
				//ؽƮΰ  ˾Ƽ ڸ.
				if(nChar + m_ElementPool[i].GetSize() <= m_nMaxChar)
				{
					nChar += m_ElementPool[i].GetSize();
					nBufSize += sprintf_s(szDest+nBufSize,2048-nBufSize,"%s",m_ElementPool[i].GetString().c_str());
				}
				else
				{
					string strSource = m_ElementPool[i].GetString();
					string strFixedString;

					int nRemainCharN = m_nMaxChar-nChar;

					for(int i=0;i<strSource.length();i++)
					{
						int j=0;
						if(IsDBCSLeadByteEx(949,strSource[i]))
						{
							j=2;
						}
						else
						{
							j=1;
						}
						
						if(nRemainCharN-j<0)
						{
							nLineN++;
							if(nLineN >= nMaxLine)
								break;
							strFixedString += m_strRetChar;
							nRemainCharN = m_nMaxChar;
						}

						if(j==2)
						{
							strFixedString.push_back(strSource[i++]);
							nRemainCharN--;
						}
						strFixedString.push_back(strSource[i]);
						nRemainCharN--;
					}// for

					nChar = m_nMaxChar - nRemainCharN;
					nBufSize += sprintf_s(szDest+nBufSize,2048-nBufSize,"%s",strFixedString.c_str());

				}//m_nMaxChar
			}//GetType()
		}//bIgnored
	}//for Size();
}